## gasnet 2025.8.0

=== tests/harness/ammpi/Makefile ===
all: 
	@echo This Makefile is not intended to be called directly.
	@echo It is used for running unit tests within the automated testing harness provided with the Berkeley UPC runtime.
	@echo For information on downloading and using Berkeley UPC, see: https://upc.lbl.gov
	@exit 1

# legacy harness support
GASNET_BLDDIR ?= $(TOP_BUILDDIR)/gasnet

PERL ?= perl
AMX_FLAVOR=mpi
CONDUIT_DIR=$(GASNET_BLDDIR)/$(AMX_FLAVOR)-conduit
CONDUIT_FRAG=$(CONDUIT_DIR)/$(AMX_FLAVOR)-seq.mak
AMX_DIR=$(GASNET_BLDDIR)/other/am$(AMX_FLAVOR)
SPAWNER_DIR=$(CONDUIT_DIR)/contrib
SPAWNER=gasnetrun_mpi gasnetrun_mpi.pl

Makefile: $(CONDUIT_FRAG)
$(CONDUIT_FRAG):
	@if test -d $(CONDUIT_DIR) ; then                                \
	   $(MAKE) -C $(CONDUIT_DIR) $(@F) || exit 1                     \
	 else                                                            \
	   echo ERROR: $(AMX_FLAVOR)-conduit build directory not found ; \
	 fi
-include $(CONDUIT_DIR)/$(AMX_FLAVOR)-seq.mak

amxdist: force
PASSTHRU_PHONY=check check-exports tests amxdist

$(PASSTHRU_PHONY): force
	$(MAKE) -C $(AMX_DIR) $@
	@echo '#!/bin/sh' > $@ ; chmod +x $@

distcheck: $(SPAWNER) force
	rm -Rf am$(AMX_FLAVOR)[0-9].[0-9]*
	$(MAKE) -C $(AMX_DIR) amxdist
	@set -x ; \
	 TESTDIR=`pwd` ; \
	 cd $(AMX_DIR) && \
	 VERSION=`/bin/ls -t am$(AMX_FLAVOR)*.tar.gz | $(PERL) -ne 'if (m@am$(AMX_FLAVOR)(.+)\.tar.gz@) { print "$$1"; exit; }'` ; \
	 DIR="am$(AMX_FLAVOR)$$VERSION" ; \
	 gunzip -c $$DIR.tar.gz | tar xvf - && \
	 cd $$DIR && \
	 $(MAKE) all tests CC="$(GASNET_LD)" && \
	 cp ./testam$(EXESUFFIX) $$TESTDIR/$@$(EXESUFFIX)

test%: $(SPAWNER) force
	$(MAKE) -C $(AMX_DIR) $@
	@cp $(AMX_DIR)/$@$(EXESUFFIX) $@$(EXESUFFIX)

$(SPAWNER):
	$(MAKE) -C $(SPAWNER_DIR) $@
	cp $(SPAWNER_DIR)/$@ $@

force:

.PHONY: force

=== tests/harness/amudp/Makefile ===
all: 
	@echo This Makefile is not intended to be called directly.
	@echo It is used for running unit tests within the automated testing harness provided with the Berkeley UPC runtime.
	@echo For information on downloading and using Berkeley UPC, see: https://upc.lbl.gov
	@exit 1

# legacy harness support
GASNET_BLDDIR ?= $(TOP_BUILDDIR)/gasnet

PERL ?= perl
AMX_FLAVOR=udp
CONDUIT_DIR=$(GASNET_BLDDIR)/$(AMX_FLAVOR)-conduit
CONDUIT_FRAG=$(CONDUIT_DIR)/$(AMX_FLAVOR)-seq.mak
AMX_DIR=$(GASNET_BLDDIR)/other/am$(AMX_FLAVOR)

Makefile: $(CONDUIT_FRAG)
$(CONDUIT_FRAG):
	@if test -d $(CONDUIT_DIR) ; then                                \
	   $(MAKE) -C $(CONDUIT_DIR) $(@F) || exit 1                     \
	 else                                                            \
	   echo ERROR: $(AMX_FLAVOR)-conduit build directory not found ; \
	 fi
-include $(CONDUIT_DIR)/$(AMX_FLAVOR)-seq.mak

amxdist: force
PASSTHRU_PHONY=check check-exports tests amxdist

$(PASSTHRU_PHONY): force
	$(MAKE) -C $(AMX_DIR) $@
	@echo '#!/bin/sh' > $@ ; chmod +x $@

distcheck: force
	rm -Rf am$(AMX_FLAVOR)[0-9].[0-9]*
	$(MAKE) -C $(AMX_DIR) amxdist
	@set -x ; \
	 TESTDIR=`pwd` ; \
	 cd $(AMX_DIR) && \
	 VERSION=`/bin/ls -t am$(AMX_FLAVOR)*.tar.gz | $(PERL) -ne 'if (m@am$(AMX_FLAVOR)(.+)\.tar.gz@) { print "$$1"; exit; }'` ; \
	 DIR="am$(AMX_FLAVOR)$$VERSION" ; \
	 gunzip -c $$DIR.tar.gz | tar xvf - && \
	 cd $$DIR && \
	 $(MAKE) all tests CC="$(GASNET_CC)" CXX="$(GASNET_LD)" && \
	 cp ./amudprun$(EXESUFFIX) $$TESTDIR/amudprun-sa$(EXESUFFIX) && \
	 cp ./testam$(EXESUFFIX) $$TESTDIR/$@$(EXESUFFIX)

amudprun:
	$(MAKE) -C $(AMX_DIR) $@$(EXESUFFIX)
	@cp $(AMX_DIR)/$@$(EXESUFFIX) .

# This target tests the Makefile target that builds amudprun for the host system 
# When cross-compiling, this requries access to host compilers (which differ from the usual target compilers)
# UPCR and harness have proper support for host C compilers, but unfortunately not host C++ compilers
# For non-cross-compile, we default these to GASNet's target C++ compiler
# For cross-compile, the user should set HOST_CXX(FLAGS) in the harness environment
# We deliberately ban the MANUAL_* flags here, as they may not be appropriate for the host compiler
# note this "banning" is only effective for cross-compile, otherwise MANUAL_CFLAGS is already folded into HOST_CFLAGS by harness
amudprun-host:
	rm -Rf $(GASNET_BLDDIR)/other/amudp/.host
	@echo "Harness default settings:" 1>&2 ; \
	 set -x ; HOST_CC='$(HOST_CC)' HOST_CFLAGS='$(HOST_CFLAGS)' HOST_CXX='$(HOST_CXX)' HOST_CXXFLAGS='$(HOST_CXXFLAGS)' HOST_LDFLAGS='$(HOST_LDFLAGS)' HOST_LIBS='$(HOST_LIBS)' ; set +x ; \
	 if test -z "$$HOST_CXX" ; then \
	   echo "Defaulting HOST_CXX(FLAGS) to GASNET_CXX(FLAGS)" 1>&2 ; set -x ; \
	   eval HOST_`$(MAKE) --no-print-directory -f $(GASNET_BLDDIR)/Makefile echovar VARNAME=CXX` ; \
	   eval HOST_`$(MAKE) --no-print-directory -f $(GASNET_BLDDIR)/Makefile echovar VARNAME=CXXFLAGS` ; \
	 fi ; \
	 set -x ; \
	 $(MAKE) -C $(AMX_DIR) $@$(EXESUFFIX) CC="$$HOST_CC $$HOST_CFLAGS" CXX="$$HOST_CXX $$HOST_CXXFLAGS" platform_ldflags="$$HOST_LDFLAGS $$HOST_LIBS" \
	                                      MANUAL_CFLAGS='' MANUAL_CXXFLAGS='' MANUAL_DEFINES='' MANUAL_LIBS='' MANUAL_LDFLAGS=''
	@cp $(AMX_DIR)/$@$(EXESUFFIX) .

test%: amudprun force
	$(MAKE) -C $(AMX_DIR) $@
	@cp $(AMX_DIR)/$@$(EXESUFFIX) .

force:

.PHONY: force

=== tests/harness/external-chapel/Makefile ===
CHAPEL_GIT_REPO   ?= chapel-lang/chapel
CHAPEL_GIT_COMMIT ?= main# was 'master' prior to June 21, 2021
CHAPEL_MAKE_ARGS  ?= -j4
CHAPEL_BLDDIR     ?= $(HARNESS_WORKDIR)/chapel
CHAPEL_TMPDIR     ?= $(HARNESS_WORKDIR)/chapel-tmp
CHAPEL_HOME       ?= $(HARNESS_WORKDIR)/chapel-inst
CHAPEL_CONDUIT    ?= $(NETWORK) # Default to same conduit as the enclosing harness run
CHAPEL_PATH_PRE   ?=# empty - if set must end with :
CHAPEL_PATH_POST  ?=# empty - if set must start with :
CHAPEL_SHELL      ?= $(shell test -n "$${ZSH_VERSION+set}$${BASH_VERSION+set}" && echo bash || echo sh)

# legacy harness support
GASNET_SRCDIR ?= $(TOP_SRCDIR)/gasnet

# Since some time in late April 2021, unset is no longer acceptable in general
CHPL_LLVM ?= none

HARNESS_LOGDIR    ?= .
LOGFILE           ?= $(HARNESS_LOGDIR)/chapel.log

# Paths and options for standard tools
PERL              ?= perl
WGET              ?= wget -nv
GZCAT             ?= gzip -cd
TAR               ?= tar
UNZIP             ?= unzip
P7ZIP             ?= 7za
GIT               ?= git

# Must not inherit these from harness environment:
unexport LD LDFLAGS LIBS
unexport CC CFLAGS
unexport CXX CXXFLAGS
unexport AR RANLIB

# Parametrized support for download/unpack
CHAPEL_DOWNLOAD ?=# one of "unzip", "p7zip" or "tgz", default to auto-detect from downloaded archive suffix
chapel_dl_suffix_unzip := .zip
chapel_dl_suffix_p7zip := .zip
chapel_dl_suffix_tgz   := .tar.gz
chapel_dl_suffix=$(chapel_dl_suffix_$(strip $(CHAPEL_DOWNLOAD)))
ifeq ($(strip $(chapel_dl_suffix)),)
chapel_dl_suffix := .zip
endif

CHAPEL_URL      ?= https://github.com/$(CHAPEL_GIT_REPO)/archive/$(CHAPEL_GIT_COMMIT)$(chapel_dl_suffix)
CHAPEL_ARCHIVE  ?= $(notdir $(CHAPEL_URL))
chapel-download: force
	rm -Rf $(CHAPEL_BLDDIR) $(CHAPEL_TMPDIR) && mkdir $(CHAPEL_TMPDIR)
	if ( expr $(CHAPEL_URL) : file:/ || expr /$(CHAPEL_URL) : // ) >/dev/null; then \
	  set -x ; cd $(CHAPEL_TMPDIR) && ln -s $(CHAPEL_URL:file:%=%) . ; \
	else \
	  set -x ; cd $(CHAPEL_TMPDIR) && $(WGET) $(CHAPEL_URL) 2>&1 || ( cat wget-log 2> /dev/null ; exit 3 ) || exit $$? ; \
	fi
	cd $(CHAPEL_TMPDIR) && cat wget-log 2> /dev/null ; rm -f wget-log ; exit 0
	@CHAPEL_TESTDIR=`pwd` && \
	 cd $(CHAPEL_TMPDIR) && CHAPEL_ARCHIVE=`/bin/ls` && CHAPEL_DOWNLOAD="$(strip $(CHAPEL_DOWNLOAD))" && \
	 if test -z "$$CHAPEL_DOWNLOAD" ; then \
	   case "$$CHAPEL_ARCHIVE" in \
	     *.zip)          CHAPEL_DOWNLOAD=unzip ;; \
	     *.p7z|*.7z)     CHAPEL_DOWNLOAD=p7zip ;; \
	     *.tar.gz|*.tgz) CHAPEL_DOWNLOAD=tgz   ;; \
	     *) echo "ERROR: Unknown archive suffix on '$$CHAPEL_ARCHIVE': Set CHAPEL_DOWNLOAD=(unzip,p7zip,tgz)" ; exit 1; \
	   esac \
	 fi && \
	 echo Fetched $$CHAPEL_ARCHIVE : CHAPEL_DOWNLOAD=$$CHAPEL_DOWNLOAD && \
	 $(MAKE) -f $$CHAPEL_TESTDIR/Makefile chapel-unpack-$$CHAPEL_DOWNLOAD CHAPEL_ARCHIVE="$$CHAPEL_ARCHIVE" && \
	 rm -f $(CHAPEL_TMPDIR)/$$CHAPEL_ARCHIVE
	mv $(CHAPEL_TMPDIR)/* $(CHAPEL_BLDDIR) # archive's root dir will vary
	rmdir $(CHAPEL_TMPDIR)
# Three ways to unpack the archive:
#  Option 1: "unzip" - .zip w/ unzip
#   This is the favored approach because it gives us the hash and uses a widely available utility.
chapel-unpack-unzip: force; $(UNZIP) -z $(CHAPEL_ARCHIVE) && $(UNZIP) -q $(CHAPEL_ARCHIVE)
#  Option 2: "p7zip" - .zip w/ 7za (from p7zip package)
#   This also gives us the hash, but uses a less widely available utility.
#   However, it is sometimes necessary because many unzip installations contain a bug w.r.t. symlinks
chapel-unpack-p7zip: force; $(P7ZIP) x -bd $(CHAPEL_ARCHIVE)
#  Option 3: "tgz" - tar + gzip
#   This is the most portable, but cannot extract the hash unless git is available
chapel-unpack-tgz:   force
	-$(GZCAT) $(CHAPEL_ARCHIVE) | $(GIT) get-tar-commit-id; exit 0
	$(GZCAT) $(CHAPEL_ARCHIVE) | $(TAR) xf -
####
.PHONY: chapel-download chapel-unpack-unzip chapel-unpack-p7zip chapel-unpack-tgz

ifneq ($(strip $(CHPL_COMM_DEBUG)),)
CHPL_GASNET_MORE_CFG_OPTIONS += --enable-debug
CHAPEL_MAKE_RUNTIME_ARGS += DEBUG=1 WARNINGS=1 ASSERTS=1
endif
CHAPEL_MAKE_ARGS += CHPL_GASNET_MORE_CFG_OPTIONS="$(CHPL_GASNET_MORE_CFG_OPTIONS)"

# Define CHPL_LAUNCHER for some conduits without our desired defaults.
# Note that these have not necessarily all been tested.
chapel_launcher_opt = $(chapel_launcher_$(strip $(CHAPEL_CONDUIT)))

# Kludge some launchers that can be constructed as a simple delta from another:
chapel-launcher: force
	@true  # currently no special cases to deal with here
clone-launcher: force
	src=gasnetrun_$(SRC_CONDUIT); dst=gasnetrun_$(DST_CONDUIT); \
	cd $(CHAPEL_BLDDIR)/runtime/src/launch && \
	if test -d $$dst; then \
	  echo ERROR: target $$dst of $@ exists >&2; exit 1; \
	fi && \
	cp -Rp $$src $$dst && \
	mv $$dst/launch-$$src.c $$dst/launch-$$dst.c && \
	$(PERL) -pi -e 's/_$(SRC_CONDUIT)/_$(DST_CONDUIT)/g' -- $$dst/*
.PHONY: chapel-launcher clone-launcher

COMMON_ENV = PATH=$(CHAPEL_PATH_PRE)$$PATH$(CHAPEL_PATH_POST) \
             CHPL_LLVM=$(CHPL_LLVM)

CONFIG_ENV = $(COMMON_ENV) $(chapel_launcher_opt) \
             CHPL_COMM=gasnet CHPL_COMM_SUBSTRATE=$(CHAPEL_CONDUIT)
ifneq ($(strip $(CHPL_COMM_DEBUG)),)
COMMON_ENV += CHPL_COMM_DEBUG=$(CHPL_COMM_DEBUG)
endif

# Apply upsteam or local patches, if any
chapel_patches ?=
chapel-patch: force
	cd $(CHAPEL_BLDDIR) && \
	for p in $(chapel_patches); do $(WGET) $$p && patch -p1 < `basename $$p`; done
.PHONY: chapel-patch

# Build and (optionally) install Chapel compiler and runtime
_chapel: force
	rm -f chapel-built
	$(call safe_tee_dance, $(MAKE) chapel-download)
	$(call safe_tee_dance, $(MAKE) chapel-patch)
	$(MAKE) chapel-launcher
	cd $(CHAPEL_BLDDIR)/third-party/gasnet && mv gasnet-src gasnet-src.dist
	cp -Rp $(GASNET_SRCDIR) $(CHAPEL_BLDDIR)/third-party/gasnet/gasnet-src
	mkdir -p "$(CHAPEL_HOME)"
	cd $(CHAPEL_BLDDIR) && . util/setchplenv.$(CHAPEL_SHELL) && (                       \
	  env $(CONFIG_ENV) $(CHAPEL_BUILD_ENV) ./configure --chpl-home="$(CHAPEL_HOME)" && \
	  env $(COMMON_ENV) $(CHAPEL_BUILD_ENV) $(MAKE) $(CHAPEL_MAKE_ARGS) compiler &&     \
	  env $(COMMON_ENV) $(CHAPEL_BUILD_ENV) $(MAKE) $(CHAPEL_MAKE_ARGS) $(CHAPEL_MAKE_RUNTIME_ARGS) runtime && \
	  env $(COMMON_ENV) $(CHAPEL_BUILD_ENV) $(MAKE) $(CHAPEL_MAKE_ARGS) all             \
	) >> $(LOGFILE) 2>&1
	if test "$(CHAPEL_HOME)" != "$(CHAPEL_BLDDIR)"; then \
	  cd $(CHAPEL_BLDDIR) && . util/setchplenv.$(CHAPEL_SHELL) &&                   \
	  env $(COMMON_ENV) $(CHAPEL_BUILD_ENV) $(MAKE) $(CHAPEL_MAKE_ARGS) install &&  \
	  env $(COMMON_ENV) $(CHAPEL_BUILD_ENV) $(MAKE) $(CHAPEL_MAKE_ARGS) clean;      \
	fi >> $(LOGFILE) 2>&1
	@echo '#!/bin/sh' > $@ ; chmod +x $@
	@touch chapel-built

_chapel_clean: force
	cd $(CHAPEL_BLDDIR) && . util/setchplenv.$(CHAPEL_SHELL) && \
	  env $(COMMON_ENV) $(CHAPEL_BUILD_ENV) \
	    $(MAKE) $(CHAPEL_MAKE_ARGS) clean >> $(LOGFILE) 2>&1
	@echo '#!/bin/sh' > $@ ; chmod +x $@

# Not reliable other than on UDP, and wants to *run* the test
check: chapel-built
	cd $(CHAPEL_BLDDIR) && . util/setchplenv.$(CHAPEL_SHELL) && \
	  env $(COMMON_ENV) $(CHAPEL_CHECK_ENV) \
	    $(MAKE) check
	@echo '#!/bin/sh' > $@ ; chmod +x $@

#
# Build one test
#
test_common: chapel-built
	rm -f $(TEST_EXE) $(TEST_EXE)_real
	cd $(CHAPEL_HOME) && . util/setchplenv.$(CHAPEL_SHELL) && cd $(CURDIR) && \
	  env $(COMMON_ENV) $(CHAPEL_TEST_ENV) \
	    $(MAKE) -C $(CHAPEL_BLDDIR)/$(TEST_DIR) $(REAL_EXE) CHPL_FLAGS+="$(chpl_flags_$(TEST_EXE))" 2>&1
	mv $(CHAPEL_BLDDIR)/$(TEST_DIR)/$(REAL_EXE) $(TEST_EXE)
	if test -e $(CHAPEL_BLDDIR)/$(TEST_DIR)/$(REAL_EXE)_real; then \
	  mv $(CHAPEL_BLDDIR)/$(TEST_DIR)/$(REAL_EXE)_real $(TEST_EXE)_real; \
	fi
one_test: force  # Using the tests natural name
	$(MAKE) test_common REAL_EXE=$(TEST_EXE)
alt_test: force  # Using an alternate test name
	$(MAKE) test_common
.PHONY: test_common one_test alt_test


# top-level examples
EXAMPLES = hello hello2-module hello3-datapar hello4-datapar-dist hello5-taskpar hello6-taskpar-dist
$(EXAMPLES): force; $(MAKE) one_test TEST_EXE=$@ TEST_DIR=examples

# directory examples/benchmarks
BENCHMARKS = lcals lulesh miniMD
$(BENCHMARKS): force; $(MAKE) one_test TEST_EXE=$@ TEST_DIR=examples/benchmarks/$@

# directory examples/benchmarks/hpcc
HPCC = stream stream-ep ra ra-atomics
$(HPCC): force; $(MAKE) one_test TEST_EXE=$@ TEST_DIR=examples/benchmarks/hpcc
chpl_flags_ra = -O -s useOn=true
chpl_flags_ra-atomics = -O
unexport $(addprefix chpl_flags_,$(HPCC))

# directory examples/benchmarks/isx
ISX = isx-strong isx-weak isx-weakISO
$(ISX): force; $(MAKE) alt_test TEST_EXE=$@ REAL_EXE=isx TEST_DIR=examples/benchmarks/isx

# directory examples/primers
PRIMERS = \
        arrays arrayVectorOps associative atomics chpldoc.doc classes         \
        distributions domains fileIO genericClasses iterators locales         \
        modules opaque parIters procedures randomNumbers ranges reductions    \
        slices sparse syncsingle taskParallel timers varargs variables        \
        voidVariables
$(PRIMERS): force; $(MAKE) one_test TEST_EXE=$@ TEST_DIR=examples/primers/$@

# directory examples/programs
PROGRAMS = beer genericStack jacobi linkedList norm prodCons quicksort tree
$(PROGRAMS): force; $(MAKE) one_test TEST_EXE=$@ TEST_DIR=examples/programs/$@

force:

.PHONY: force

# Run a command, with output to both stdout and $(LOGFILE), preserving exit code of the command
# Based on https://unix.stackexchange.com/questions/14270/get-exit-status-of-process-thats-piped-to-another/70675#70675
safe_tee_dance = (((($1; echo $$? >&3) 2>&1 | tee -a $(LOGFILE) >&4) 3>&1) | (read rc; exit $$rc)) 4>&1

=== tests/harness/external-legion/Makefile ===
LEGION_GIT_REPO   ?= StanfordLegion/legion
LEGION_GIT_COMMIT ?= stable
LEGION_BLDDIR     ?= $(HARNESS_WORKDIR)/legion
LEGION_TMPDIR     ?= $(HARNESS_WORKDIR)/legion-tmp
LEGION_GASNET     ?= # Path to an existing installation, if any
LEGION_CONDUIT    ?= $(NETWORK) # Default to same conduit as the enclosing harness run
LEGION_MAKE_ARGS  ?= -j4

# legacy harness support
GASNET_BLDDIR ?= $(TOP_BUILDDIR)/gasnet

HARNESS_LOGDIR    ?= .
LOGFILE = $(HARNESS_LOGDIR)/legion.log
TO_LOG = >> $(LOGFILE) 2>&1

# Paths and options for standard tools
WGET              ?= wget -nv
GZCAT             ?= gzip -cd
TAR               ?= tar
UNZIP             ?= unzip
P7ZIP             ?= 7za
GIT               ?= git

# Strip whitespace to simplify later use
LEGION_GASNET  := $(strip $(LEGION_GASNET))
LEGION_CONDUIT := $(strip $(LEGION_CONDUIT))

# Logic to extract GASNet's compiler variables.
# We use a sub-shell to avoid pulling in the entire makefile fragment.
# TODO: may want to handle LDFLAGS here as well?
GASNET_VARS = $(shell $(MAKE) --no-print-directory echovars FRAGMENT=$(LEGION_CONDUIT))
FRAGMENT=#empty by default
ifneq ($(FRAGMENT),)
include $(LEGION_GASNET_INST)/include/$(FRAGMENT)-conduit/$(FRAGMENT)-par.mak
echovars: force; @echo "CC='$(GASNET_CC)' CXX='$(GASNET_CXX)'"
.PHONY: echovars
endif

RUNTIME_TARGETS = librealm.a liblegion.a
SEED_DIR = $(LEGION_BLDDIR)/examples/circuit # NOTE: must not be an OMP or CUDA test
ifeq ($(LEGION_GASNET1),1)
  LEGION_NET_ENV = USE_GASNET=1 GASNET="$(LEGION_GASNET_INST)"
else
  LEGION_NET_ENV = REALM_NETWORKS=gasnetex GASNET_ROOT="$(LEGION_GASNET_INST)"
endif
COMMON_ENV = \
	LG_RT_DIR="$(LEGION_BLDDIR)/runtime" \
	$(LEGION_NET_ENV) CONDUIT=$(LEGION_CONDUIT) \
	$(GASNET_VARS)
DO_MAKE = env $(COMMON_ENV) $(LEGION_TEST_ENV) $(MAKE) $(LEGION_MAKE_ARGS)

# Parametrized support for download/unpack
LEGION_DOWNLOAD ?=# one of "unzip", "p7zip" or "tgz", default auto-detects using LEGION_URL suffix
LEGION_DOWNLOAD := $(strip $(LEGION_DOWNLOAD))
legion_dl_suffix_unzip := .zip
legion_dl_suffix_p7zip := .zip
legion_dl_suffix_tgz   := .tar.gz
legion_dl_suffix=$(legion_dl_suffix_$(LEGION_DOWNLOAD))
ifeq ($(strip $(legion_dl_suffix)),)
legion_dl_suffix := .zip
endif

LEGION_URL      ?= https://github.com/$(LEGION_GIT_REPO)/archive/$(LEGION_GIT_COMMIT)$(legion_dl_suffix)
LEGION_ARCHIVE  ?= $(notdir $(LEGION_URL))
legion-download: force
	rm -Rf $(LEGION_BLDDIR) $(LEGION_TMPDIR) && mkdir $(LEGION_TMPDIR)
	if ( expr $(LEGION_URL) : file:/ || expr /$(LEGION_URL) : // ) >/dev/null; then \
	  set -x ; cd $(LEGION_TMPDIR) && ln -s $(LEGION_URL:file:%=%) . ; \
	else \
	  set -x ; cd $(LEGION_TMPDIR) && $(WGET) $(LEGION_URL) 2>&1 || ( cat wget-log 2> /dev/null ; exit 3 ) || exit $$? ; \
	fi
	cd $(LEGION_TMPDIR) && cat wget-log 2> /dev/null ; rm -f wget-log ; exit 0
	@LEGION_TESTDIR=`pwd` && \
	 cd $(LEGION_TMPDIR) && LEGION_ARCHIVE=`/bin/ls` && LEGION_DOWNLOAD="$(LEGION_DOWNLOAD)" && \
	 if test -z "$$LEGION_DOWNLOAD" ; then \
	   case "$$LEGION_ARCHIVE" in \
	     *.zip)          LEGION_DOWNLOAD=unzip ;; \
	     *.p7z|*.7z)     LEGION_DOWNLOAD=p7zip ;; \
	     *.tar.gz|*.tgz) LEGION_DOWNLOAD=tgz   ;; \
	     *) echo "ERROR: Unknown archive suffix on '$$LEGION_ARCHIVE': Set LEGION_DOWNLOAD=(unzip,p7zip,tgz)" ; exit 1; \
	   esac \
	 fi && \
	 echo Fetched $$LEGION_ARCHIVE : LEGION_DOWNLOAD=$$LEGION_DOWNLOAD && \
	 $(MAKE) -f $$LEGION_TESTDIR/Makefile legion-unpack-$$LEGION_DOWNLOAD LEGION_ARCHIVE="$$LEGION_ARCHIVE" && \
	 rm -f $(LEGION_TMPDIR)/$$LEGION_ARCHIVE
	mv $(LEGION_TMPDIR)/* $(LEGION_BLDDIR) # archive's root dir will vary
	rmdir $(LEGION_TMPDIR)
# Three ways to unpack the archive:
#  Option 1: "unzip" - .zip w/ unzip
#   This is the favored approach because it gives us the hash and uses a widely available utility.
legion-unpack-unzip: force; $(UNZIP) -z $(LEGION_ARCHIVE) && $(UNZIP) -q $(LEGION_ARCHIVE)
#  Option 2: "p7zip" - .zip w/ 7za (from p7zip package)
#   This also gives us the hash, but uses a less widely available utility.
#   However, it is sometimes necessary because many unzip installations contain a bug w.r.t. symlinks
legion-unpack-p7zip: force; $(P7ZIP) x -bd $(LEGION_ARCHIVE)
#  Option 3: "tgz" - tar + gzip
#   This is the most portable, but cannot extract the hash unless git is available
legion-unpack-tgz:   force
	-$(GZCAT) $(LEGION_ARCHIVE) | $(GIT) get-tar-commit-id; exit 0
	$(GZCAT) $(LEGION_ARCHIVE) | $(TAR) xf -
####
.PHONY: legion-download legion-unpack-unzip legion-unpack-p7zip legion-unpack-tgz

# Apply upsteam or local patches, if any
legion_patches ?=
legion-patch: force
	cd $(LEGION_BLDDIR) && \
	for p in $(legion_patches); do $(WGET) $$p && patch -p1 < `basename $$p`; done
.PHONY: legion-patch

# Either install GASNet (empty LEGION_GASNET) or use in-place
ifeq ($(LEGION_GASNET),)
export LEGION_GASNET_INST = $(LEGION_BLDDIR)/gasnet
legion-gasnet: force
	if test -d "$(LEGION_GASNET_INST)"; then \
	  rm -Rf "$(LEGION_GASNET_INST)";  \
	elif test -e "$(LEGION_GASNET_INST)"; then \
	  rm -f "$(LEGION_GASNET_INST)";  \
	fi
	@echo ======== Installing GASNet at $(LEGION_GASNET_INST) ========
	$(MAKE) install -C $(GASNET_BLDDIR) prefix="$(LEGION_GASNET_INST)"
else
export LEGION_GASNET_INST = $(LEGION_GASNET)
legion-gasnet: force
	@if test -f "$(LEGION_GASNET_INST)/include/gasnet.h"; then \
	  echo ======== Using GASNet pre-installed at $(LEGION_GASNET_INST) ========; \
	else \
	  echo ERROR: No GASNet install at $(LEGION_GASNET_INST) \
	  exit 1; \
	fi
endif
.PHONY: legion-gasnet

# Symlink or simple script that corresponds to
#    RunCmd = ./launcher -np %N %P %A
launcher:
	case $(LEGION_CONDUIT) in \
	smp) echo '#!/bin/sh' > $@ ; \
	     echo 'N=$$2;shift 2;eval env GASNET_PSHM_NODES=$$N "$$@"' >> $@ ; \
	     chmod +x $@;; \
	udp) ln -s "$(LEGION_GASNET_INST)"/bin/amudprun $@;; \
	  *) ln -s "$(LEGION_GASNET_INST)"/bin/gasnetrun_$(LEGION_CONDUIT) $@;; \
	esac

# Pre-build the runtime libs to separate the output from that of first test build
rtlibs: force
	( echo ======== Prebuild Legion RT libs in $(SEED_DIR) ========; \
	  $(DO_MAKE) -C $(SEED_DIR) $(RUNTIME_TARGETS) \
	) $(TO_LOG)
.PHONY: rtlibs

_legion_clean: force
	( echo ======== Cleaning Legion RT libs via $(SEED_DIR) ========; \
	  $(DO_MAKE) -C $(SEED_DIR) clean \
	) $(TO_LOG)
	@echo '#!/bin/sh' > $@ ; chmod +x $@
.PHONY: _legion_clean
	
_legion: force
	rm -Rf legion-built launcher $(LOGFILE)
	$(call safe_tee_dance, $(MAKE) legion-download)
	$(call safe_tee_dance, $(MAKE) legion-patch)
	$(PERL) -pi -e s,mpi_interop,realm_saxpy,g -- $(LEGION_BLDDIR)/test.py # replace bogus test
	$(call safe_tee_dance, $(MAKE) legion-gasnet)
	@echo '#!/bin/sh' > $@ ; chmod +x $@
	$(MAKE) launcher rtlibs
	@touch legion-built

# Runs of test.py:
TESTS_PY = legion_cxx regent fuzzer realm external private perf
$(TESTS_PY): legion-built
	cd $(LEGION_BLDDIR) && \
	env $(COMMON_ENV) LAUNCHER="echo Would run: " $(LEGION_TEST_ENV) \
	    ./test.py --use gasnet --test $@ 2>&1
	@echo '#!/bin/sh' > $@ ; chmod +x $@


# Build a single test
one_test: legion-built
	( echo ======== Rebuild Legion RT libs in $(TEST_DIR) ========; \
	  $(DO_MAKE) -C $(LEGION_BLDDIR)/$(TEST_DIR) $(RUNTIME_TARGETS) \
	) $(TO_LOG)
	$(DO_MAKE) -C $(LEGION_BLDDIR)/$(TEST_DIR)
	mv $(LEGION_BLDDIR)/$(TEST_DIR)/$(TEST_EXE) .
	( cd $(LEGION_BLDDIR)/$(TEST_DIR) &&               \
          rm -f $(TEST_EXE).o $(RUNTIME_TARGETS) || exit 0 \
	) $(TO_LOG)

# examples/:
EXAMPLES = circuit dynamic_registration ghost ghost_pull realm_saxpy spmd_cgsolver virtual_map 
$(EXAMPLES): force; $(MAKE) one_test TEST_DIR=examples/$@ TEST_EXE=$@

# tutorial/:
TUTORIALS = hello_world tasks_and_futures index_tasks global_vars logical_regions \
            physical_regions privileges partitioning multiple_partitions custom_mapper 
$(TUTORIALS): force; $(MAKE) one_test TEST_DIR=tutorial/??_$@ TEST_EXE=$@

# test/:
TESTS = attach_file_mini
$(TESTS): force; $(MAKE) one_test TEST_DIR=test/$@ TEST_EXE=$@

force:

.PHONY: force one_test $(TESTS_PY)

# Run a command, with output to both stdout and $(LOGFILE), preserving exit code of the command
# Based on https://unix.stackexchange.com/questions/14270/get-exit-status-of-process-thats-piped-to-another/70675#70675
safe_tee_dance = (((($1; echo $$? >&3) 2>&1 | tee -a $(LOGFILE) >&4) 3>&1) | (read rc; exit $$rc)) 4>&1

=== tests/harness/external-upcxx/Makefile ===
UPCXX_GIT_REPO          ?=# Set to a git repo address to enable git-based fetch
UPCXX_EXTRAS_GIT_REPO   ?=# Set to a git repo address to enable git-based fetch
UPCXX_GIT_COMMIT        ?= develop
UPCXX_EXTRAS_GIT_COMMIT ?= develop
UPCXX_BLDDIR     ?= $(HARNESS_WORKDIR)/upcxx
UPCXX_INSTDIR    ?= $(HARNESS_WORKDIR)/upcxx-inst
UPCXX_TMPDIR     ?= $(HARNESS_WORKDIR)/upcxx-tmp
UPCXX_CONDUIT    ?= $(NETWORK)# Default to same conduit as the enclosing harness run
UPCXX_EXTRA_FLAGS ?=# extra flags to add to both compilers for lib and tests, may be set by pushbuild/end-user
UPCXX_EXTRA_TEST_FLAGS ?=# extra flags to add to tests (but not lib), may be set by pushbuild/end-user
UPCXX_TEST_FLAGS  ?=# per-test flags reserved for use by harness.conf
UPCXX_CONFIGURE_EXTRA ?=# extra flags to add to UPC++ configure command line
UPCXX_MAKE_J     ?= -j4 # concurrency of GNU Make steps
UPCXX_FC         ?= $(shell which gfortran)

# legacy harness support
GASNET_BLDDIR ?= $(TOP_BUILDDIR)/gasnet

# ensure all child invocations see the same conduit defined by UPCXX_CONDUIT,
# even if the enclosing environment contains conflicting values
export UPCXX_NETWORK := $(UPCXX_CONDUIT)
export UPCXX_GASNET_CONDUIT := $(UPCXX_CONDUIT)

# Options for providing GASNET:
# 1. set UPCXX_GASNET to an existing build path to use.
# The remaining options assume $(GASNET_BLDDIR) is a valid build dir
# 2. set UPCXX_GASNET to an existing source path to use.
#    This one notably implies this CI will configure and build GASNet.
# 3. set UPCXX_TARBALL_GASNET=1 to create a GASNet tarball and use it
#    This one notably implies this CI will configure and build GASNet.
# 4. Default is to point at the existing $(GASNET_BLDDIR) build.
#
# All three options will use the provided build directory only in the
# '_upcxx' test (the UPC++ configure step) and not after.
ifneq ($(strip $(UPCXX_GASNET)),)
  UPCXX_EXTERNAL_GASNET:=1
  CONFIGURE_GASNET:=$(strip $(UPCXX_GASNET))
ifeq ($(wildcard $(strip $(UPCXX_GASNET))/gasnet_config.h),)
  UPCXX_GASNET_SOURCES:=1
endif
else 
ifneq ($(strip $(UPCXX_TARBALL_GASNET)),)
  CONFIGURE_GASNET:=$(UPCXX_BLDDIR)/gasnet.tar.gz  # actual filename will vary
  UPCXX_GASNET_SOURCES:=1
else # default to using builddir
  CONFIGURE_GASNET:=$(GASNET_BLDDIR)
endif
endif
ifeq ($(UPCXX_GASNET_SOURCES),1)
  # UPCXX_GASNET=srcdir and UPCXX_TARBALL_GASNET configure GASNet
  CONFIGURE_FRAGMENTS:=$(GASNET_BLDDIR)
  # Don't pollute configure with harness flags
  UNSET_VARS = CFLAGS CXXFLAGS CPPFLAGS LDFLAGS LIBS
endif
CONFIGURE_FRAGMENTS ?= $(CONFIGURE_GASNET)
UPCXX_TESTMODE  ?= wrap

HARNESS_LOGDIR    ?= .
LOGFILE = $(HARNESS_LOGDIR)/upcxx.log
TO_LOG = >> $(LOGFILE) 2>&1

# Various UPC++ scripts require bash
SHELL := /bin/bash
PIPEEXIT := ; ( exit $${PIPESTATUS[0]} ) # bashism to preserve first exit code in a pipe

# Paths and options for standard tools
WGET              ?= wget -nv
GZCAT             ?= gzip -cd
TAR               ?= tar
UNZIP             ?= unzip
P7ZIP             ?= 7za
GIT               ?= git
PERL              ?= perl  # only used in the check-testsuite target

# GASNET_CODEMODE currently simply follows UPCXX_CODEMODE
GASNET_CODEMODE=$(UPCXX_CODEMODE)

# Logic to extract GASNet's compiler variables.
# intentionally ignore the environment here because it is set by harness
# use UPCXX_TEST_ENV to override if necessary.
# We use a sub-shell to avoid pulling in the entire makefile fragment.
# TODO: may want to handle LDFLAGS here as well?
GASNET_VARS = $(shell $(MAKE) --no-print-directory echovars FRAGMENT=$(strip $(UPCXX_CONDUIT)))
FRAGMENT=#empty by default
ifneq ($(FRAGMENT),) # use any fragment we can find
-include $(CONFIGURE_FRAGMENTS)/$(FRAGMENT)-conduit/$(FRAGMENT)-seq.mak
-include $(CONFIGURE_FRAGMENTS)/$(FRAGMENT)-conduit/$(FRAGMENT)-par.mak
echovars: force; @echo "CC='$(GASNET_CC)' CXX='$(GASNET_CXX)'"
.PHONY: echovars
endif

ifneq ($(strip $(UPCXX_TEST_ENV)),)
DO_ENV := export $(UPCXX_TEST_ENV)
else
DO_ENV := : # empty command to be safely preceded or followed by '&&' or ';'
endif

CONFIGURE_ENV = \
	export $(GASNET_VARS) && $(DO_ENV) && \
        export CC="$$CC $(strip $(UPCXX_EXTRA_FLAGS))" CXX="$$CXX $(strip $(UPCXX_EXTRA_FLAGS))"

# UPCXX_EXTRA_FLAGS must be applied on three distinct paths:
#
# 1. When building libupcxx (LIB_BUILD_ENV)
#    If NOT configuring GASNet, then UPCXX_EXTRA_FLAGS needs to appear
#    in the MANUAL_{C,CXX}FLAGS when libupcxx is built, otherwise the
#    setting of CONFIGURE_ENV, above, is sufficient
ifneq ($(strip $(UPCXX_EXTRA_FLAGS)),)
ifneq ($(UPCXX_GASNET_SOURCES),1)
LIB_BUILD_ENV = env MANUAL_CFLAGS="$(strip $(UPCXX_EXTRA_FLAGS))" MANUAL_CXXFLAGS="$(strip $(UPCXX_EXTRA_FLAGS))"
endif
endif
#
# 2. When building tests via inst-test, wrap-test or using CMake
#    This is handled by upcxx-meta, which will record the configure-time
#    values of CC and CXX even when this CI is not configuring GASNet
#
# 3. When building make-based tests (MAKE_TEST_ENV)
#    Handled by setting CC and CXX to their values reported by upcxx-meta
MAKE_TEST_ENV = \
	    CC="$$($(UPCXX_INSTDIR)/bin/upcxx-meta CC)" \
	   CXXFLAGS="$(UPCXX_EXTRA_TEST_FLAGS) $(UPCXX_TEST_FLAGS)" \
	   CXX="$$($(UPCXX_INSTDIR)/bin/upcxx-meta CXX) $(UPCXX_EXTRA_TEST_FLAGS) $(UPCXX_TEST_FLAGS)" \
	   UPCXX_INSTALL=$(UPCXX_INSTDIR)

# Parametrized support for download/unpack
UPCXX_DOWNLOAD ?=# one of "unzip", "p7zip" or "tgz", default to auto-detect from downloaded archive suffix
upcxx_dl_suffix_unzip := .zip
upcxx_dl_suffix_p7zip := .zip
upcxx_dl_suffix_tgz   := .tar.gz
upcxx_dl_suffix=$(upcxx_dl_suffix_$(strip $(UPCXX_DOWNLOAD)))
ifeq ($(strip $(upcxx_dl_suffix)),)
upcxx_dl_suffix := .zip
endif

#UPCXX_URL      ?= https://upc-bugs.lbl.gov/nightly/unlisted/berkeleylab-upcxx-$(UPCXX_GIT_COMMIT)$(upcxx_dl_suffix)
UPCXX_URL      ?= https://bitbucket.org/berkeleylab/upcxx/get/$(UPCXX_GIT_COMMIT)$(upcxx_dl_suffix)
#UPCXX_EXTRAS_URL  ?= https://upc-bugs.lbl.gov/nightly/unlisted/berkeleylab-upcxx-extras-$(UPCXX_EXTRAS_GIT_COMMIT).tar.gz
UPCXX_EXTRAS_URL  ?= https://bitbucket.org/berkeleylab/upcxx-extras/get/$(UPCXX_EXTRAS_GIT_COMMIT)$(upcxx_dl_suffix)

VERSION_FILE=$(HARNESS_LOGDIR)/git_$(PRODUCT)
upcxx-download: force
	rm -Rf $(DESTDIR) $(UPCXX_TMPDIR) && mkdir $(UPCXX_TMPDIR)
	@if test -n "$(GIT_REPO)" ; then \
	    set -x ; cd $(UPCXX_TMPDIR) && $(GIT) archive --remote=$(GIT_REPO) --format=zip --prefix=git-archive/ --output=git-archive.zip $(GIT_COMMIT) || exit 2 ; \
	 elif ( expr $(URL) : file:/ || expr /$(URL) : // ) >/dev/null; then \
	    set -x ; cd $(UPCXX_TMPDIR) && ln -s $(URL:file:%=%) . ; \
	 else \
	    set -x ; cd $(UPCXX_TMPDIR) && $(WGET) $(URL) 2>&1 || ( cat wget-log 2> /dev/null ; exit 3 ) || exit $$? ; \
	 fi
	cd $(UPCXX_TMPDIR) && cat wget-log 2> /dev/null ; rm -f wget-log ; exit 0
	@UPCXX_TESTDIR=`pwd` && \
	 cd $(UPCXX_TMPDIR) && UPCXX_ARCHIVE=`/bin/ls` && UPCXX_DOWNLOAD="$(strip $(UPCXX_DOWNLOAD))" && \
	 if test -z "$$UPCXX_DOWNLOAD" ; then \
	   case "$$UPCXX_ARCHIVE" in \
	     *.zip)          UPCXX_DOWNLOAD=unzip ;; \
	     *.p7z|*.7z)     UPCXX_DOWNLOAD=p7zip ;; \
	     *.tar.gz|*.tgz) UPCXX_DOWNLOAD=tgz   ;; \
	     *) echo "ERROR: Unknown archive suffix on '$$UPCXX_ARCHIVE': Set UPCXX_DOWNLOAD=(unzip,p7zip,tgz)" ; exit 1; \
	   esac \
	 fi && \
	 echo Fetched $$UPCXX_ARCHIVE : UPCXX_DOWNLOAD=$$UPCXX_DOWNLOAD && \
	 $(MAKE) -f $$UPCXX_TESTDIR/Makefile upcxx-unpack-$$UPCXX_DOWNLOAD UPCXX_ARCHIVE="$$UPCXX_ARCHIVE" && \
	 rm -f $(UPCXX_TMPDIR)/$$UPCXX_ARCHIVE
	mv $(UPCXX_TMPDIR)/* $(DESTDIR) # archive's root dir will vary
	rmdir $(UPCXX_TMPDIR)
	@echo "$(PRODUCT) version: `cat $(VERSION_FILE) 2>/dev/null`"
	@if grep -q '^#define' $(DESTDIR)/src/git_version.h 2>/dev/null ; then \
	  ver=`grep '^#define' $(DESTDIR)/src/git_version.h | cut -f3 -d' '` ; \
	  if test -n "$$ver" ; then \
	    echo "$$ver" > $(VERSION_FILE) ; \
	    echo "$(PRODUCT) describe: $$ver" ; \
	  fi; \
	fi
# Three ways to unpack the archive:
#  Option 1: "unzip" - .zip w/ unzip
#   This is the favored approach because it gives us the hash and uses a widely available utility.
upcxx-unpack-unzip: force; $(UNZIP) -qz $(UPCXX_ARCHIVE) > $(VERSION_FILE) && $(UNZIP) -q $(UPCXX_ARCHIVE)
#  Option 2: "p7zip" - .zip w/ 7za (from p7zip package)
#   This also gives us the hash, but uses a less widely available utility.
#   However, it is sometimes necessary because many unzip installations contain a bug w.r.t. symlinks
upcxx-unpack-p7zip: force
	$(P7ZIP) x -bd $(UPCXX_ARCHIVE) 2>&1 | tee -a $(VERSION_FILE).p7z $(PIPEEXIT)
	@-grep 'Comment = ' $(VERSION_FILE).p7z | cut -f3 -d' ' > $(VERSION_FILE)
#  Option 3: "tgz" - tar + gzip
#   This is the most portable, but cannot extract the hash unless git is available
upcxx-unpack-tgz:   force
	@-$(GZCAT) $(UPCXX_ARCHIVE) | $(GIT) get-tar-commit-id > $(VERSION_FILE) ; exit 0
	$(GZCAT) $(UPCXX_ARCHIVE) | $(TAR) xf -
####
.PHONY: upcxx-download upcxx-unpack-unzip upcxx-unpack-p7zip upcxx-unpack-tgz

# Symlink or simple script that corresponds to
#    RunCmd = ./launcher -np %N %P %A
launcher:
	-rm -f $@
	@UPCXXRUN=$(UPCXX_INSTDIR)/bin/upcxx-run; \
	 if test -f $$UPCXXRUN ; then set -x ; \
	   ln -s $$UPCXXRUN $@ ; \
	 else \
	   echo "ERROR: $$UPCXXRUN is missing" ; exit 1 ; \
	 fi 

# similar for MPI progs
# best-effort when missing mpi-conduit:
# 1. leverage conduit's launcher
#    a. some conduit's gasnetrun_ may be a valid mpi launcher
#    b. other conduit's may support mpi-spawner
# 2. final fallback is mpirun
launcher-mpi:
	-rm -f $@
	@gasnet_bindir=$(UPCXX_INSTDIR)/gasnet.$(GASNET_CODEMODE)/bin; \
	 if test -x $$gasnet_bindir/gasnetrun_mpi ; then \
	  set -x ; ln -s $$gasnet_bindir/gasnetrun_mpi $@ ; \
	 else \
	  conduit_launcher=$$gasnet_bindir/gasnetrun_$(UPCXX_CONDUIT); \
	  case "$(UPCXX_CONDUIT)" in \
	    *) \
	      if test -r $$conduit_launcher-mpi.pl ; then \
	        mpi_launcher="$$conduit_launcher -spawner=mpi"; \
	      else \
	        mpi_launcher=mpirun; \
	      fi; \
	      set -x; \
	      echo '#!/bin/sh' > $@ ; \
	      echo "exec $$mpi_launcher" '"$$@"' >> $@ ; \
	      echo 'echo "ERROR: failed to find mpirun, gasnetrun_mpi or a conduit-specific alternative." ; exit 1' >> $@ ; \
	      chmod +x $@ \
	      ;; \
	  esac; \
	fi

_upcxx: force
	-rm -Rf upcxx-built upcxx-install launcher launcher-mpi $(LOGFILE)
	echo ======== UPCXX download ======== | tee $(LOGFILE) $(PIPEEXIT)
	( set -x ; $(MAKE) upcxx-download PRODUCT=upcxx URL=$(UPCXX_URL) GIT_REPO=$(UPCXX_GIT_REPO) GIT_COMMIT=$(UPCXX_GIT_COMMIT) DESTDIR=$(UPCXX_BLDDIR) ) 2>&1 | tee -a $(LOGFILE) $(PIPEEXIT)
	echo ======== UPCXX EXTRAS download ======== | tee -a $(LOGFILE) $(PIPEEXIT)
	( set -x ; $(MAKE) upcxx-download PRODUCT=upcxx_extras URL=$(UPCXX_EXTRAS_URL) GIT_REPO=$(UPCXX_EXTRAS_GIT_REPO) GIT_COMMIT=$(UPCXX_EXTRAS_GIT_COMMIT) DESTDIR=$(UPCXX_BLDDIR)/extras ) 2>&1 | tee -a $(LOGFILE) ; exit 0 # deliberately ignore failures
	@echo UPCXX_GASNET=$(UPCXX_GASNET) UPCXX_BLDDIR=$(UPCXX_BLDDIR) $(TO_LOG)
	@echo CONFIGURE_GASNET=$(CONFIGURE_GASNET) CONFIGURE_FRAGMENTS=$(CONFIGURE_FRAGMENTS) $(TO_LOG)
	@if test -n "$(UPCXX_EXTERNAL_GASNET)" ; then \
	  echo ======== UPCXX_GASNET:external ========; set -x; \
	elif test -n "$(UPCXX_TARBALL_GASNET)" ; then \
	  echo ======== UPCXX_GASNET:tarball ========; set -x; \
	  $(MAKE) dist -C $(GASNET_BLDDIR) ; \
	else \
	  echo ======== UPCXX_GASNET:builddir ========; set -x; \
	fi $(TO_LOG)
	-echo PATH="$$PATH" $(TO_LOG)
	@-( set -x; $(CONFIGURE_ENV) ; $$CC  --version ) 2>&1 | egrep -i -v -e error -e warning $(TO_LOG)
	@-( $(CONFIGURE_ENV) ; set -x ; $$CXX --version ) 2>&1 | egrep -i -v -e error -e warning $(TO_LOG)
	@-( $(CONFIGURE_ENV) ; set -x ; $(MAKE) --version ) 2>&1 | egrep -i -v -e error -e warning $(TO_LOG)
	@-( $(CONFIGURE_ENV) ; set -x ; $(CMAKE) --version ) 2>&1 | egrep -i -v -e error -e warning $(TO_LOG)
	@( echo ======== Configure UPCXX ========; set -x; \
	   if test -n "$(UPCXX_TARBALL_GASNET)" ; then \

=== tests/harness/gasnet-tests/Makefile ===
all: 
	@echo This Makefile is not intended to be called directly.
	@echo It is used for running unit tests within the automated testing harness provided with the Berkeley UPC runtime.
	@echo For information on downloading and using Berkeley UPC, see: https://upc.lbl.gov
	@exit 1

# legacy harness support
UPCR_BLDDIR ?= $(TOP_BUILDDIR)
GASNET_BLDDIR ?= $(TOP_BUILDDIR)/gasnet
GASNET_SRCDIR ?= $(TOP_SRCDIR)/gasnet

PERL ?= perl
CONDUIT_DIR=$(GASNET_BLDDIR)/$(NETWORK)-conduit

testcxx%:       force ; $(MAKE) do-cxx-test EXE=$@
testlegacycxx%: force ; $(MAKE) do-cxx-test EXE=$@

do-cxx-test: force
	@if test -n "`$(UPCC) --network=udp --echo-var UPCR_LD 2>/dev/null`"; then      \
	  makename=`echo $(EXE) | $(PERL) -pe 's/_.*-(seq|par|parsync)$$/-$$1/'`;       \
	   cmdname=`echo $(EXE) | $(PERL) -pe 's/(_.*)?-(seq|par|parsync)$$//'`;        \
	   echo "$$makename => $$cmdname => $(EXE)" ; set -x ;                          \
	   $(MAKE) -C $(CONDUIT_DIR) $$makename MANUAL_CXXFLAGS="$(MANUAL_CXXFLAGS)" && \
	   cp -f $(CONDUIT_DIR)/$$cmdname$(EXESUFFIX) $(EXE)$(EXESUFFIX);               \
	 else                                                                           \
	   echo '#!/bin/sh' > $(EXE) ; chmod +x $(EXE);                                 \
	 fi

# One rule to rule them all
# test(.*)(_.*)?-(seq|par|parsync) gets made as test$1-$3 into executable test$1 and copied to $0
test%: force
	@makename=`echo $@ | $(PERL) -pe 's/_.*-(seq|par|parsync)$$/-$$1/'`; \
	 cmdname=`echo $@ | $(PERL) -pe 's/(_.*)?-(seq|par|parsync)$$//'`; \
	 echo "$$makename => $$cmdname => $@" ; set -x ; \
         $(MAKE) -C $(CONDUIT_DIR) $$makename MANUAL_CFLAGS="$(MANUAL_CFLAGS)" && \
         cp -f $(CONDUIT_DIR)/$$cmdname$(EXESUFFIX) $@$(EXESUFFIX)

testconduitspecific: force
	@if test "$(NETWORK)" = "mpi" ; then 	\
           conduit_test=testmpi ;		\
           conduit_mode=par ;			\
         fi ;					\
	 if test "$(NETWORK)" = "udp" ; then 	\
           conduit_test=testcxx ;		\
           conduit_mode=par ;			\
         fi ;					\
	 if test "$$conduit_test" = "" ; then 	\
           conduit_test=testam ;		\
           conduit_mode=parsync ;		\
         fi ;					\
         $(MAKE) -C $(CONDUIT_DIR) $$conduit_test-$$conduit_mode MANUAL_CFLAGS="$(MANUAL_CFLAGS)" && \
	 cp -f $(CONDUIT_DIR)/$$conduit_test$(EXESUFFIX) $@$(EXESUFFIX)

parsync: force
	@$(MAKE) -C $(CONDUIT_DIR) $@
	@echo '#!/bin/sh' > $@ ; chmod +x $@

ident:
	cp -f $(GASNET_SRCDIR)/other/contrib/ident .

check-exports: force
	@$(MAKE) -C $(CONDUIT_DIR) $@
	@echo '#!/bin/sh' > $@ ; chmod +x $@

check-tools-exports: force
	@$(MAKE) -C $(GASNET_BLDDIR) check-exports
	@echo '#!/bin/sh' > $@ ; chmod +x $@

check-libupcr-exports: force
	@$(MAKE) -C $(UPCR_BLDDIR) check-exports
	@echo '#!/bin/sh' > $@ ; chmod +x $@

do-check-other: force
	@rm -f $(GASNET_BLDDIR)/other/check-pp-tgt$(EXESUFFIX)
	@$(MAKE) -C $(GASNET_BLDDIR)/other check-local
	@cp -f $(GASNET_BLDDIR)/other/check-pp-tgt$(EXESUFFIX) $(EXE)$(EXESUFFIX)

check-other:          force ; $(MAKE) do-check-other EXE=$@
check-other-cross:    force ; $(MAKE) do-check-other EXE=$@
check-other-pedantic: force ; $(MAKE) do-check-other EXE=$@

force:

.PHONY: force

=== tests/harness/libgasnet/Makefile ===
all: 
	@echo This Makefile is not intended to be called directly.
	@echo It is used for running unit tests within the automated testing harness provided with the Berkeley UPC runtime.
	@echo For information on downloading and using Berkeley UPC, see: https://upc.lbl.gov
	@exit 1

# legacy harness support
GASNET_SRCDIR ?= $(TOP_SRCDIR)/gasnet
GASNET_BLDDIR ?= $(TOP_BUILDDIR)/gasnet

PERL ?= perl
LIBGASNET_LOGDIR ?= $(HARNESS_LOGDIR)
LIBGASNET_CONFIGURE ?= configure# can also be cross-configure-*
LIBGASNET_CONFIGURE_ARGS ?=$(shell $(PERL) -ne 'if (m/^\s*CONFIGURE_ARGS\s*=\s*(.*)$$/) { print $$1; }' < $(GASNET_BLDDIR)/Makefile )# configure args
LIBGASNET_CONFIGURE_ARGS_EXTRA ?=# extra configure args to append
LIBGASNET_CONFIGURE_ENV ?=# envvars for configure
SUITE_BUILD_DIR:=$(shell pwd)/bgasnet

do-configure: force
	rm -Rf $(SUITE_BUILD_DIR)$(BUILD_VARIANT)
	mkdir $(SUITE_BUILD_DIR)$(BUILD_VARIANT)
	@logfile=$(LIBGASNET_LOGDIR)/libgasnet-configure$(BUILD_VARIANT).log ; \
	 configure=$(GASNET_SRCDIR)/$(LIBGASNET_CONFIGURE) ; \
	 crossconfig=$(GASNET_SRCDIR)/other/contrib/$(LIBGASNET_CONFIGURE) ; \
	 if ! test -x $$configure && test -x $$crossconfig ; then \
	   ln -s $$crossconfig $$configure ; \
	 fi ; \
	 set -x ; \
	 ( cd $(SUITE_BUILD_DIR)$(BUILD_VARIANT) && \
	   env $(LIBGASNET_CONFIGURE_ENV) \
	   $$configure $(LIBGASNET_CONFIGURE_ARGS) $(LIBGASNET_CONFIGURE_ARGS_EXTRA) ) > $$logfile 2>&1 ; \
	 rc=$$? ; cat $$logfile ; exit $$rc

_configure: force
	@rm -f $@
	$(MAKE) do-configure BUILD_VARIANT=
	@echo '#!/bin/sh' > $@ ; chmod +x $@

_configure_%: force
	@rm -f $@
	$(MAKE) do-configure BUILD_VARIANT=$(patsubst _configure%,%,$@)
	@echo '#!/bin/sh' > $@ ; chmod +x $@

do-preclean-mpi: force
	$(MAKE) -C $(SUITE_BUILD_DIR)/other/ammpi clean

do-preclean-udp: force
	$(MAKE) -C $(SUITE_BUILD_DIR)/other/amudp clean

do-preclean-%: force
	echo $@

do-clean: force
	$(MAKE) do-preclean-$(NETWORK)
	$(MAKE) -C $(SUITE_BUILD_DIR)/$(NETWORK)-conduit clean

do-conduit: force
	$(MAKE) do-clean
	$(MAKE) -C $(SUITE_BUILD_DIR)/$(NETWORK)-conduit $(MAKE_TARGET)
	$(MAKE) do-clean

LIBGASNET_PEDANTIC_WOFF ?=
LIBGASNET_PEDANTIC_WOFF_C ?=
LIBGASNET_PEDANTIC_WOFF_CXX ?=
LIBGASNET_PEDANTIC_FLAGS ?= \
  MANUAL_CFLAGS="-std=c99 -pedantic $(LIBGASNET_PEDANTIC_WOFF) $(LIBGASNET_PEDANTIC_WOFF_C)" \
  MANUAL_CXXFLAGS="-std=c++11 -pedantic $(LIBGASNET_PEDANTIC_WOFF) $(LIBGASNET_PEDANTIC_WOFF_CXX)"

pedantic-%: $(SUITE_BUILD_DIR) force
	@rm -f $@
	@network=`echo $@ | $(PERL) -pe 's/^(.*)-(.*)-(.*)$$/$$2/'`; \
	 target=`echo $@ | $(PERL) -pe 's/^(.*)-(.*)-(.*)$$/$$3/'`; \
	 logfile=$(LIBGASNET_LOGDIR)/libgasnet-$@.log ; \
	 set -x ; \
	 ( $(MAKE) do-conduit NETWORK=$$network MAKE_TARGET=$$target $(LIBGASNET_PEDANTIC_FLAGS) ) > $$logfile 2>&1 ; \
	 rc=$$? ; cat $$logfile ; exit $$rc
	@echo '#!/bin/sh' > $@ ; chmod +x $@

LIBGASNET_ALT_TEST ?= testgasnet

do-alt-test: $(SUITE_BUILD_DIR) force
	@rm -f $(TARGET)
	@network=`echo $(TARGET) | $(PERL) -pe 's/^(.*)-(.*)-(.*)$$/$$2/'`; \
	 parseq=`echo $(TARGET) | $(PERL) -pe 's/^(.*)-(.*)-(.*)$$/$$3/'`; \
	 logfile=$(LIBGASNET_LOGDIR)/libgasnet-$(TARGET).log ; \
	 set -x ; \
	 case $(LIBGASNET_ALT_TEST) in \
	   none) target=$$parseq;; \
	      *) target=$(LIBGASNET_ALT_TEST)-$$parseq;; \
	 esac; \
	 ( $(MAKE) do-conduit NETWORK=$$network MAKE_TARGET=$$target ) > $$logfile 2>&1 ; \
	 rc=$$? ; cat $$logfile ; exit $$rc
	@echo '#!/bin/sh' > $(TARGET) ; chmod +x $(TARGET)

alt_t-%:  force ; $(MAKE) do-alt-test TARGET=$@ SUITE_BUILD_DIR='$(SUITE_BUILD_DIR)_alt_t'
alt_s-%:  force ; $(MAKE) do-alt-test TARGET=$@ SUITE_BUILD_DIR='$(SUITE_BUILD_DIR)_alt_s'
alt_ts-%: force ; $(MAKE) do-alt-test TARGET=$@ SUITE_BUILD_DIR='$(SUITE_BUILD_DIR)_alt_ts'
	 
force:

.PHONY: force

=== debian/changelog ===
gasnet (2025.8.0-1) experimental; urgency=medium

  * Initial release. (Closes: #1126449)

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 09 Feb 2026 08:37:33 +0000

=== debian/control ===
Source: gasnet
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Alastair McKinstry <mckinstry@debian.org>
Section: devel
Build-Depends: debhelper-compat (= 13),
               libhwloc-dev,
               mpi-default-dev,
	       librdmacm-dev [!hurd-any],
	       libslurm-dev (>= 23.11) [!hurd-any],
	       libibverbs-dev,
	       libfabric-dev [!hurd-any !powerpc !sh4],
	       libnuma-dev [!hurd-any],
	       libucx-dev [amd64 arm64 ppc64el riscv64 loong64],
               chrpath
Rules-Requires-Root: no
Standards-Version: 4.7.3
Vcs-Browser: https://salsa.debian.org/science-team/gasnet
Vcs-Git: https://salsa.debian.org/science-team/gasnet.git -b debian/latest
Homepage: https://www.mpich.org/

Package: libgasnet-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: ${misc:Depends}
Description: Development files for GASNET
 GASNet is a language-independent, networking middleware layer that provides
 network-independent, high-performance communication primitives including
 Remote Memory Access (RMA) and Active Messages (AM).
 It has been used to implement parallel programming models and libraries
 such as UPC, UPC++, Fortran coarrays, Legion, Chapel, and many others.
 The interface is primarily intended as a compilation target and for use
 by runtime library writers (as opposed to end users), and the primary goals
 are high performance, interface portability, and expressiveness.
 GASNet stands for "Global-Address Space Networking".
 .
 This package provides the static libraries and include files for GasNET.

Package: gasnet
Architecture: any
Multi-Arch: foreign
Depends: 
         ${misc:Depends},
  	 ${perl:Depends},
         ${shlibs:Depends}
Description: Global-Address Space Networking - binary tools
 GASNet is a language-independent, networking middleware layer that provides
 network-independent, high-performance communication primitives including
 Remote Memory Access (RMA) and Active Messages (AM).
 It has been used to implement parallel programming models and libraries
 such as UPC, UPC++, Fortran coarrays, Legion, Chapel, and many others.
 The interface is primarily intended as a compilation target and for use
 by runtime library writers (as opposed to end users), and the primary goals
 are high performance, interface portability, and expressiveness.
 GASNet stands for "Global-Address Space Networking".
 .
 This package includes the program binaries necessary to run GasNET programs.

=== debian/rules ===
#!/usr/bin/make -f

# export DH_VERBOSE=1


DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
PKGDIR = debian/libgasnet-dev/usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig


%:
	dh $@ 

override_dh_auto_configure:
	dh_auto_configure -- --enable-ucx


execute_after_dh_install:
	rm -rf $(PKGDIR)
	# Move the perlstart scripts
	mkdir -p debian/gasnet/usr/share/gasnet
	mv debian/gasnet/usr/bin/*.pl debian/gasnet/usr/share/gasnet


#override_dh_gencontrol:
#        dh_gencontrol -- -V'archlist:ucx=$(CH4_UCX_ARCH)'
